diff -r 43a3cb39a786 scripts/build/libc/newlib.sh
--- a/scripts/build/libc/newlib.sh	Wed Dec 14 19:57:47 2011 +0100
+++ b/scripts/build/libc/newlib.sh	Wed Dec 28 23:37:38 2011 +0100
@@ -15,10 +15,11 @@
 
 do_libc_get() {
     local libc_src
-    local avr32headers_src
+    local avr32headers_src="http://www.atmel.com/dyn/resources/prod_documents"
+          avr32headers_base="avr32-headers-3.2.3.258"    # used below
+    local avr32headers_ext=".zip"
 
     libc_src="ftp://sources.redhat.com/pub/newlib"
-    avr32headers_src="http://dev.doredevelopment.dk/avr32-toolchain/sources"
 
     if [ -z "${CT_LIBC_NEWLIB_CVS}" ]; then
         CT_GetFile "newlib-${CT_LIBC_VERSION}" ${libc_src}
@@ -31,7 +32,7 @@
     fi
 
     if [ "${CT_ATMEL_AVR32_HEADERS}" = "y" ]; then
-        CT_GetFile "avr32headers" ${avr32headers_src}
+        CT_GetFile ${avr32headers_base} ${avr32_headers_ext} ${avr32headers_src}
     fi
 }
 
@@ -40,7 +41,9 @@
     CT_Patch "newlib" "$(libc_newlib_version)"
 
     if [ "${CT_ATMEL_AVR32_HEADERS}" = "y" ]; then
-        CT_Extract "avr32headers"
+        # The avr32header zip file extracts to avr32/*.h
+        # Put that in its directory, the same as normal tarballs
+        CT_Extract ${avr32headers_base} -d ${CT_SRC_DIR}/${avr32headers_base}
     fi
 }
 
@@ -137,7 +140,7 @@
     
     if [ "${CT_ATMEL_AVR32_HEADERS}" = "y" ]; then
         CT_DoLog EXTRA "Installing Atmel's AVR32 headers"
-        CT_DoExecLog ALL cp -r ${CT_SRC_DIR}/avr32headers "${CT_PREFIX_DIR}/${CT_TARGET}/include/avr32"
+        CT_DoExecLog ALL cp -r ${CT_SRC_DIR}/${avr32headers_base}/avr32 "${CT_PREFIX_DIR}/${CT_TARGET}/include/"
     fi
 
     CT_EndStep
diff -r 43a3cb39a786 scripts/functions
--- a/scripts/functions	Wed Dec 14 19:57:47 2011 +0100
+++ b/scripts/functions	Wed Dec 28 23:37:38 2011 +0100
@@ -410,6 +410,7 @@
     printf ".tar.bz2\n"
     printf ".tar.gz\n.tgz\n"
     printf ".tar\n"
+    printf ".zip\n"
 }
 
 # Get the file name extension of a component
@@ -705,7 +706,7 @@
 # by the caller, that did a 'cd' into the correct path before calling us
 # and sets nochdir to 'nochdir'.
 # Note also that this function handles the git trees!
-# Usage: CT_Extract <basename> [nochdir] [options]
+# Usage: CT_Extract [nochdir] <basename> [options]
 # where 'options' are dependent on the source (eg. git branch/tag...)
 CT_Extract() {
     local nochdir="$1"
@@ -770,6 +771,7 @@
         .tar.bz2)     bzip2 -dc "${full_file}" | CT_DoExecLog FILE tar "${tar_opts[@]}" -f -;;
         .tar.gz|.tgz) gzip -dc "${full_file}" | CT_DoExecLog FILE tar "${tar_opts[@]}" -f -;;
         .tar)         CT_DoExecLog FILE tar "${tar_opts[@]}" -f "${full_file}";;
+        .zip)         CT_DoExecLog FILE unzip "${@}" "${full_file}";;
         /.git)        CT_ExtractGit "${basename}" "${@}";;
         *)            CT_DoLog WARN "Don't know how to handle '${basename}${ext}': unknown extension"
                       return 1
